/**
***     SocketApp.c
***
***     ̃\[XR[h́AG[XgbvTXyhȂǂ̏Ă܂B
***     Copyright (C) 2006 SophiaCradle Incorporated.
***     All rights reserved.
**/

#include "AEEModGen.h"
#include "AEEAppGen.h"
#include "AEEStdLib.h"
#include "AEEShell.h"
#include "Common.h"
#include "SocketApp.bid"
#include "AEENet.h"

#define     ACCESS_URL      ("www.google.com")

// Avbg\
typedef struct SocketApp {
    AEEApplet a; // Avbg\̂̐擪o͕K AEEApplet ^ɂ邱ƁB
    Common common; // ʕ`p

    // ʐMp
    INetMgr* netmgr;        // INetMgr C^[tF[X̃CX^Xϐ
    ISocket* socket;        // ISocket C^[tF[X̃CX^Xϐ
    uint16 index;           // Mf[^ʂi[
    AEEDNSResult dnsresult; // ڑzXg IP AhXi[
    AEECallback callback;   // R[obN֐Ƃ̈i[
} SocketApp;

static boolean SocketApp_HandleEvent(SocketApp* app, AEEEvent eCode, uint16 wParam, uint32 dwParam);
static boolean OnAppStart(SocketApp* app);
static boolean OnAppStop(SocketApp* app);
static boolean OnKey(SocketApp* app, uint16 key);
static void TCPConnect(SocketApp* pApp);
static void TCPDNSConnect(void* p);
static void TCPConnected(void* p, int nErr);
static void TCPWrite(SocketApp* pApp);
static void TCPRead(SocketApp* pApp);

int AEEClsCreateInstance(AEECLSID ClsId, IShell* pIShell, IModule* po, void** ppObj)
{
    *ppObj = NULL;
    if (ClsId == AEECLSID_SOCKETAPP) {
        if (AEEApplet_New(sizeof(SocketApp), ClsId, pIShell, po, (IApplet**)ppObj, (AEEHANDLER)SocketApp_HandleEvent, NULL) == TRUE) {
            return AEE_SUCCESS;
        }
    }
    return EFAILED;
}

static boolean SocketApp_HandleEvent(SocketApp* app, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{
    switch (eCode) {
        case EVT_APP_START:
            return OnAppStart(app);

        case EVT_APP_STOP:
            return OnAppStop(app);

        case EVT_KEY:
            return OnKey(app, wParam);
    }
    return FALSE;
}

// AvbgJnƂɌĂяoB
static boolean OnAppStart(SocketApp* app)
{
    IShell* shell = app->a.m_pIShell;
    IDisplay* display = app->a.m_pIDisplay;

    app->socket = NULL;
    ISHELL_CreateInstance(shell, AEECLSID_NET, (void**)&app->netmgr);
    COMMON_Init(&app->common, display, shell, 32768);
    COMMON_WriteString(&app->common, "Push Select Key...\n");
    COMMON_Draw(&app->common);
    return TRUE;
}

// AvbgIƂɌĂяoB
static boolean OnAppStop(SocketApp* app)
{
    // e
    if (app->socket != NULL) {
        ISOCKET_Cancel(app->socket, NULL, NULL);
        ISOCKET_Release(app->socket);
    }
    INETMGR_Release(app->netmgr);
    COMMON_Free(&app->common);
    return TRUE;
}

// L[ꂽƂɌĂяoB
static boolean OnKey(SocketApp* app, uint16 key)
{
    switch (key) {
        case AVK_SELECT:
            TCPConnect(app);
            return TRUE;

        case AVK_DOWN:
            COMMON_NextLine(&app->common);
            COMMON_Draw(&app->common);
            return TRUE;

        case AVK_UP:
            COMMON_PreviousLine(&app->common);
            COMMON_Draw(&app->common);
            return TRUE;
    }
    return FALSE;
}

// zXg IP AhX𒲂ׂB
static void TCPConnect(SocketApp* pApp)
{
    CALLBACK_Init(&pApp->callback, TCPDNSConnect, pApp);
    INETMGR_GetHostByName(pApp->netmgr, &pApp->dnsresult, ACCESS_URL, &pApp->callback);
    return;
}

// zXgɐڑB
static void TCPDNSConnect(void* p)
{
    SocketApp* pApp = (SocketApp*)p;
    int nErr = pApp->dnsresult.nResult;

    if (nErr > AEEDNSMAXADDRS) {
        // IP AhX̎擾ɎsBnErr ̒lɂČ킩B
        DBGPRINTF("** DNS Lookup Failed: Error %d\n", nErr);
    }
    else {
        pApp->socket = INETMGR_OpenSocket(pApp->netmgr, AEE_SOCK_STREAM);
        if (pApp->socket == NULL) {
            DBGPRINTF("** OpenSocket Failed: Error %d\n", INETMGR_GetLastError(pApp->netmgr));
        }
        else {
            // pApp->dnsresult.addrs[0] Ɏ擾 IP AhXێB
            // HTONS ́A|[gԍʐMpɕϊ}N֐B
            nErr = ISOCKET_Connect(pApp->socket, pApp->dnsresult.addrs[0], HTONS(80), TCPConnected, pApp);
            if (nErr != AEE_NET_SUCCESS) {
                DBGPRINTF("** Connect Failed: Error %d\n", ISOCKET_GetLastError(pApp->socket));
                ISOCKET_Cancel(pApp->socket, NULL, NULL);
                ISOCKET_Release(pApp->socket);
                pApp->socket = NULL;
            }
            else {
                DBGPRINTF("** connecting...\n");
            }
        }
    }
    return;
}

// bZ[W̑MJnB
static void TCPConnected(void* p, int nErr)
{
    SocketApp* pApp = (SocketApp*)p;

    if ((nErr == AEE_NET_SUCCESS) || (nErr == AEE_NET_EISCONN)) {
        // G[Ȃ΃bZ[W𑗐M (TCPWrite ֐)
        pApp->index = 0;
        TCPWrite(pApp);
    }
    else {
        DBGPRINTF("** Connect Failed: Error %d\n", nErr);
        ISOCKET_Cancel(pApp->socket, NULL, NULL);
        ISOCKET_Release(pApp->socket);
        pApp->socket = NULL;
    }
    return;
}

// bZ[W𑗐MAΎMJnB
static void TCPWrite(SocketApp* pApp)
{
    int nSent;
    char message[] = "GET / HTTP/1.0\n\n";

    // bZ[W̑MBԒl͎ۂɑMoCg (̓G[R[h)
    // O̓obt@̃TCY
    nSent = ISOCKET_Write(pApp->socket, (byte *)message + pApp->index, (uint16)sizeof(message) - pApp->index);
    if (nSent == AEE_NET_ERROR) {
        DBGPRINTF("** Write Failed: Error %d\n", ISOCKET_GetLastError(pApp->socket));
        ISOCKET_Cancel(pApp->socket, NULL, NULL);
        ISOCKET_Release(pApp->socket);
        pApp->socket = NULL;
    }
    else {
        // nSent  AEE_NET_WOULDBLOCK ̏ꍇ́AbZ[WMłȂB
        if (nSent != AEE_NET_WOULDBLOCK) {
            pApp->index += nSent;
            if (pApp->index >= sizeof(message)) {
                // MI
                DBGPRINTF("** writing complete...\n");
                // MJn
                TCPRead(pApp);
                return;
            }
        }
        DBGPRINTF("** writing...\n");
        // MĂȂƂ́AĂуR[obN֐i̊֐gjo^B
        ISOCKET_Writeable(pApp->socket, (PFNNOTIFY)TCPWrite, pApp);
    }
    return;
}

// bZ[WMA΃\[XJʂɕ`悷B
static void TCPRead(SocketApp * pApp)
{
    char buffer[0x7FFF];
    int nRead;

    // bZ[W̎MBԒl͎ۂɎMoCg (̓G[R[h)
    // O̓obt@̃TCY
    nRead = ISOCKET_Read(pApp->socket, (byte*)buffer, 0x7FFF - 1);
    if (nRead == AEE_NET_ERROR) {
        DBGPRINTF("** Read Failed: Error %d\n", ISOCKET_GetLastError(pApp->socket));
        ISOCKET_Cancel(pApp->socket, NULL, NULL);
        ISOCKET_Release(pApp->socket);
        pApp->socket = NULL;
    }
    else {
        // nRead  AEE_NET_WOULDBLOCK ̏ꍇ́AbZ[WMłȂB
        if (nRead != AEE_NET_WOULDBLOCK) {
            if (nRead == 0) {
                // MI
                DBGPRINTF("** reading Complete...\n");
                ISOCKET_Release(pApp->socket);
                pApp->socket = NULL;
                return;
            }
            else {
                // obt@̏I[ '\0' B
                buffer[nRead] = 0;
                // ̉ʕ`
                COMMON_WriteString(&pApp->common, buffer);
                COMMON_Draw(&pApp->common);
            }
        }
        DBGPRINTF("** reading...\n");
        // MĂȂƂ́AĂуR[obN֐i̊֐gjo^
        ISOCKET_Readable(pApp->socket, (PFNNOTIFY)TCPRead, pApp);
    }
    return;
}
